/*---------------------------------------------------------------------------*/
//       Author : hiyohiyo
//         Mail : hiyohiyo@crystalmark.info
//          Web : http://crystalmark.info/
//      License : The modified BSD license
//
//                                Copyright 2007 hiyohiyo, All rights reserved.
/*---------------------------------------------------------------------------*/

#pragma once

#ifndef __AFXWIN_H__
	#error "include 'stdafx.h' before including this file for PCH"
#endif

#define THEME_DIR					_T("resource\\theme\\")
#define LANGUAGE_DIR				_T("resource\\language\\")
#define DIALOG_DIR					_T("resource\\dialog\\")

#define MENU_THEME_INDEX			3
#define MENU_LANG_INDEX				5

#define MAIN_DIALOG					_T("Main.html")
#define ABOUT_DIALOG				_T("About.html")
#define FEATURE_FLAGS_DIALOG		_T("FeatureFlags.html")
#define BIOS_INFO_DIALOG			_T("BiosInfo.html")
#define CPUID_INFO_DIALOG			_T("CpuidInfo.html")
#define SYSTEM_INFO_DIALOG			_T("SystemInfo.html")

#define DEFAULT_THEME				THEME_DIR _T("default\\Main.css")
#define DEFAULT_LANGUAGE			LANGUAGE_DIR _T("English.lang")


#include "WmiInfo.h"
#include "resource.h"		// main symbols

class CCrystalCpuidApp : public CWinApp
{
public:
	CCrystalCpuidApp();
	virtual ~CCrystalCpuidApp();

	CWmiInfo* GetWmiInfo();

	OSVERSIONINFO m_OsVer;
	BOOL m_IsNT;

#ifdef RUN_TIME_DYNAMIC_LINKING
	HMODULE m_hOpenLibSys;
#endif

	CString m_MainDlgPath;
	CString m_AboutDlgPath;
	CString m_FeatureFlagsDlgPath;
	CString m_BiosInfoDlgPath;
	CString m_CpuidInfoDlgPath;
	CString m_SystemInfoDlgPath;

	CString m_ThemeDir;
	CString m_LangDir;
	DWORD m_ThemeIndex;
	DWORD m_LangIndex;

// Overrides
	public:
	virtual BOOL InitInstance();

// Implementation

	DECLARE_MESSAGE_MAP()

protected:
	CWmiInfo* m_WmiInfo;
};

extern CCrystalCpuidApp theApp;