/*---------------------------------------------------------------------------*/
//       Author : hiyohiyo
//         Mail : hiyohiyo@crystalmark.info
//          Web : http://crystalmark.info/
//      License : The modified BSD license
//
//                                Copyright 2007 hiyohiyo, All rights reserved.
/*---------------------------------------------------------------------------*/

#include "stdafx.h"
#include "CrystalCPUID.h"
#include "SystemInfoDlg.h"
#include "../OpenLibSys/ItemId.h"

#ifdef RUN_TIME_DYNAMIC_LINKING 
#include "../OpenLibSys/OlsApiInitExt.h"
#else // for Load-Time Dynamic Linking
#include "../OpenLibSys/OlsApi.h"
#endif

IMPLEMENT_DYNCREATE(CSystemInfoDlg, CDHtmlDialog)

CSystemInfoDlg::CSystemInfoDlg(CWnd* pParent /*=NULL*/)
	: CDHtmlDialogEx(CSystemInfoDlg::IDD, NULL, pParent)
{
	TCHAR str[256];
	GetOlsString(DMI_SM_BIOS_VERSION, str, 256);		m_SmBiosVersion = str;
	GetOlsString(DMI_BIOS_VENDOR, str, 256);			m_BiosVendor = str;
	GetOlsString(DMI_BIOS_VERSION, str, 256);			m_BiosVersion = str;
	GetOlsString(DMI_BIOS_RELEASE_DATE, str, 256);		m_BiosReleaseDate = str;
	GetOlsString(DMI_BIOS_ROM_SIZE, str, 256);			m_BiosRomSize = str;
	GetOlsString(DMI_MOTHER_MANUFACTURER, str, 256);	m_MotherManufacturer = str;
	GetOlsString(DMI_MOTHER_PRODUCT, str, 256);		m_MotherProduct = str;
	GetOlsString(DMI_MOTHER_VERSION, str, 256);		m_MotherVersion = str;
	GetOlsString(DMI_CPU_SOCKET, str, 256);			m_CpuSocket = str;
	GetOlsString(DMI_CPU_MANUFACTURER, str, 256);		m_CpuManufacturer = str;
	GetOlsString(DMI_CPU_VERSION, str, 256);			m_CpuVersion = str;
	GetOlsString(DMI_CPU_CURRENT_CLOCK, str, 256);		m_CpuCurrentClock = str;
	GetOlsString(DMI_CPU_EXTERNAL_CLOCK, str, 256);	m_CpuExternalClock = str;
	GetOlsString(DMI_CPU_MAX_CLOCK, str, 256);			m_CpuMaxClock = str;

	LARGE_INTEGER qpf;
	QueryPerformanceFrequency(&qpf);
	m_QueryPerformance.Format(_T("%.2f MHz"), qpf.QuadPart / 1000.0 / 1000.0);
}

CSystemInfoDlg::~CSystemInfoDlg()
{
}

void CSystemInfoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDHtmlDialogEx::DoDataExchange(pDX);

	DDX_DHtml_ElementText(pDX, _T("SmBiosVersion"), DISPID_IHTMLELEMENT_INNERTEXT, m_SmBiosVersion);
	DDX_DHtml_ElementText(pDX, _T("BiosVendor"), DISPID_IHTMLELEMENT_INNERTEXT, m_BiosVendor);
	DDX_DHtml_ElementText(pDX, _T("BiosVersion"), DISPID_IHTMLELEMENT_INNERTEXT, m_BiosVersion);
	DDX_DHtml_ElementText(pDX, _T("BiosReleaseDate"), DISPID_IHTMLELEMENT_INNERTEXT, m_BiosReleaseDate);
	DDX_DHtml_ElementText(pDX, _T("BiosRomSize"), DISPID_IHTMLELEMENT_INNERTEXT, m_BiosRomSize);
	DDX_DHtml_ElementText(pDX, _T("MotherManufacturer"), DISPID_IHTMLELEMENT_INNERTEXT, m_MotherManufacturer);
	DDX_DHtml_ElementText(pDX, _T("MotherProduct"), DISPID_IHTMLELEMENT_INNERTEXT, m_MotherProduct);
	DDX_DHtml_ElementText(pDX, _T("MotherVersion"), DISPID_IHTMLELEMENT_INNERTEXT, m_MotherVersion);
	DDX_DHtml_ElementText(pDX, _T("CpuSocket"), DISPID_IHTMLELEMENT_INNERTEXT, m_CpuSocket);
	DDX_DHtml_ElementText(pDX, _T("CpuManufacturer"), DISPID_IHTMLELEMENT_INNERTEXT, m_CpuManufacturer);
	DDX_DHtml_ElementText(pDX, _T("CpuVersion"), DISPID_IHTMLELEMENT_INNERTEXT, m_CpuVersion);
	DDX_DHtml_ElementText(pDX, _T("CpuCurrentClock"), DISPID_IHTMLELEMENT_INNERTEXT, m_CpuCurrentClock);
	DDX_DHtml_ElementText(pDX, _T("CpuExternalClock"), DISPID_IHTMLELEMENT_INNERTEXT, m_CpuExternalClock);
	DDX_DHtml_ElementText(pDX, _T("CpuMaxClock"), DISPID_IHTMLELEMENT_INNERTEXT, m_CpuMaxClock);
	DDX_DHtml_ElementText(pDX, _T("QueryPerformance"), DISPID_IHTMLELEMENT_INNERTEXT, m_QueryPerformance);
}

BOOL CSystemInfoDlg::OnInitDialog()
{
	CDHtmlDialogEx::OnInitDialog();

	InitDHtmlDialog(SIZE_X, SIZE_Y,
		((CCrystalCpuidApp*)AfxGetApp())->m_SystemInfoDlgPath);

	return TRUE;
}

BEGIN_MESSAGE_MAP(CSystemInfoDlg, CDHtmlDialogEx)
END_MESSAGE_MAP()

BEGIN_DHTML_EVENT_MAP(CSystemInfoDlg)
END_DHTML_EVENT_MAP()
