/*---------------------------------------------------------------------------*/
//       Author : hiyohiyo
//         Mail : hiyohiyo@crystalmark.info
//          Web : http://crystalmark.info/
//      License : The modified BSD license
//
//                           Copyright 2002-2007 hiyohiyo, All rights reserved.
/*---------------------------------------------------------------------------*/

#include "stdafx.h"
#include "WmiInfo.h"

// WMI interface
#include <wbemcli.h>
#pragma comment(lib, "wbemuuid.lib ")


typedef HRESULT(WINAPI * _CoInitializeSecurity_)(PSECURITY_DESCRIPTOR pVoid,LONG cAuthSvc,SOLE_AUTHENTICATION_SERVICE * asAuthSvc,void * pReserved1,
DWORD dwAuthnLevel,DWORD dwImpLevel,SOLE_AUTHENTICATION_LIST * pAuthList,DWORD dwCapabilities,void * pReserved3);

CWmiInfo::CWmiInfo()
{
	InitWmiInfo();
}

CWmiInfo::~CWmiInfo()
{

}

BOOL CWmiInfo::InitWmiInfo()
{
	
	try{
		HRESULT hRes = S_OK;
		CString cstr;
		DWORD uReturned = 1;

		IWbemLocator *pIWbemLocator = NULL;
		IWbemServices* pIWbemServices = NULL;
		IEnumWbemClassObject *pEnumCOMDevs = NULL;
		IWbemClassObject  *pCOMDev = NULL;

		CoInitialize( NULL );

		_CoInitializeSecurity_ CoInitializeSecurity = NULL;
		HINSTANCE hDLL = LoadLibrary(_T("ole32.dll"));
		if(hDLL != NULL)
		{
			CoInitializeSecurity = (_CoInitializeSecurity_)GetProcAddress(hDLL, "CoInitializeSecurity");
		}
		if(CoInitializeSecurity == NULL)
		{
			FreeLibrary(hDLL);
			return FALSE;
		}

		CoInitializeSecurity(NULL, -1, NULL, NULL,
			RPC_C_AUTHN_LEVEL_PKT_PRIVACY, RPC_C_IMP_LEVEL_IMPERSONATE,
			NULL, EOAC_SECURE_REFS, NULL );
		FreeLibrary(hDLL);

		if(CoCreateInstance(CLSID_WbemLocator, NULL,
			CLSCTX_INPROC_SERVER, IID_IWbemLocator,
			(LPVOID *)&pIWbemLocator) != S_OK)
		{
			return FALSE;
		}
		if(pIWbemLocator->ConnectServer(SysAllocString(L"\\\\.\\root\\cimv2"),
			NULL, NULL, 0L, 0L, NULL, NULL, &pIWbemServices) != S_OK)
		{
			return FALSE;
		}

		CoSetProxyBlanket(pIWbemServices, RPC_C_AUTHN_WINNT, RPC_C_AUTHZ_NONE,
                          NULL, RPC_C_AUTHN_LEVEL_CALL, 
                          RPC_C_IMP_LEVEL_IMPERSONATE, NULL, EOAC_NONE);

		pIWbemLocator->Release();

	/////////////////
	//BIOS
		pIWbemServices->ExecQuery(SysAllocString(L"WQL"),
			SysAllocString(L"select ReleaseDate, Version, Manufacturer,Caption, \
			SMBIOSBIOSVersion, SMBIOSMajorVersion, SMBIOSMinorVersion from Win32_BIOS"), 0, NULL, &pEnumCOMDevs);
		if(SUCCEEDED(pEnumCOMDevs->Next(2000, 1, &pCOMDev, &uReturned)) && uReturned == 1)
		{
			VARIANT  pVal;
			VariantClear(&pVal);
			if(pCOMDev->Get(L"ReleaseDate", 0L, &pVal, NULL, NULL) == WBEM_S_NO_ERROR && pVal.vt > VT_NULL)
			{
				cstr = pVal.bstrVal;
				m_BiosDate.Format(_T("%s/%s/%s"), cstr.Left(4), cstr.Mid(4, 2), cstr.Mid(6, 2));
				m_BiosDate.Replace(_T("190"), _T("200"));
				VariantClear(&pVal);
			}

			if(pCOMDev->Get(L"Version", 0L, &pVal, NULL, NULL) == WBEM_S_NO_ERROR && pVal.vt > VT_NULL)
			{
				m_BiosVersion = pVal.bstrVal;
				VariantClear(&pVal);
			}
			if(pCOMDev->Get(L"Manufacturer", 0L, &pVal, NULL, NULL) == WBEM_S_NO_ERROR && pVal.vt > VT_NULL)
			{
				m_BiosManufacturer = pVal.bstrVal;
				VariantClear(&pVal);
			}
			if(pCOMDev->Get(L"Caption", 0L, &pVal, NULL, NULL) == WBEM_S_NO_ERROR && pVal.vt > VT_NULL)
			{
				m_BiosCaption = pVal.bstrVal;
				VariantClear(&pVal);
			}
			if(pCOMDev->Get(L"SMBIOSBIOSVersion", 0L, &pVal, NULL, NULL) == WBEM_S_NO_ERROR && pVal.vt > VT_NULL)
			{
				m_SmBiosCaption = pVal.bstrVal;
				VariantClear(&pVal);
			}
			if(pCOMDev->Get(L"SMBIOSMajorVersion", 0L, &pVal, NULL, NULL) == WBEM_S_NO_ERROR && pVal.vt > VT_NULL)
			{
				m_SmBiosVersion.Format(_T("%d"), pVal.ulVal);
				VariantClear(&pVal);
			}
			if(pCOMDev->Get(L"SMBIOSMinorVersion", 0L, &pVal, NULL, NULL) == WBEM_S_NO_ERROR && pVal.vt > VT_NULL)
			{
				cstr.Format(_T(".%d"), pVal.ulVal);
				m_SmBiosVersion += cstr;
			}
			pCOMDev->Release();
		}

	/////////////////
	//Computer System
		pIWbemServices->ExecQuery(SysAllocString(L"WQL"),
			SysAllocString(L"select Manufacturer, Model from Win32_ComputerSystem"), 0, NULL, &pEnumCOMDevs);

		if(SUCCEEDED(pEnumCOMDevs->Next(2000, 1, &pCOMDev, &uReturned)) && uReturned == 1)
		{
			VARIANT  pVal;
			VariantClear(&pVal);
			if(pCOMDev->Get(L"Manufacturer", 0L, &pVal, NULL, NULL) == WBEM_S_NO_ERROR && pVal.vt > VT_NULL)
			{
				m_SystemManufacturer = pVal.bstrVal;
				VariantClear(&pVal);}
			if(pCOMDev->Get(L"Model", 0L, &pVal, NULL, NULL) == WBEM_S_NO_ERROR && pVal.vt > VT_NULL)
			{
				m_SystemModel = pVal.bstrVal;
			}
			pCOMDev->Release();
		}
	/////////////////
	//Mother
		pIWbemServices->ExecQuery(SysAllocString(L"WQL"),
			SysAllocString(L"select Manufacturer,Product, Version from Win32_BaseBoard"), 0, NULL, &pEnumCOMDevs);
		if( SUCCEEDED( pEnumCOMDevs->Next(2000, 1, &pCOMDev, &uReturned)) && uReturned == 1){
			VARIANT  pVal;
			VariantClear(&pVal);
			if(pCOMDev->Get(L"Version", 0L, &pVal, NULL, NULL) == WBEM_S_NO_ERROR && pVal.vt > VT_NULL)
			{
				m_MotherVersion = pVal.bstrVal;
				VariantClear(&pVal);
			}
			if(pCOMDev->Get(L"Product", 0L, &pVal, NULL, NULL) == WBEM_S_NO_ERROR && pVal.vt > VT_NULL)
			{
				m_MotherProduct = pVal.bstrVal;
				VariantClear(&pVal);
			}
			if(pCOMDev->Get(L"Manufacturer", 0L, &pVal, NULL, NULL) == WBEM_S_NO_ERROR && pVal.vt > VT_NULL)
			{
				m_MotherManufacturer = pVal.bstrVal;
			}
			pCOMDev->Release();
		}
	}
	catch(...)
	{
		return FALSE;
	}

	return TRUE;
}